import React, { Component } from "react";
import { connect } from "react-redux";
// import { bindActionCreators } from "redux";

import Loader from "../components/HOC/loader";
import { increase, decrease } from "../actions/todo";
import { doRequest } from "../actions/request";

import "./count.scss";

export class Count extends Component {
	componentDidMount() {
		console.log("this.props", this.props);
		this.props.doRequest(Math.floor(Math.random() * 100 + 1));
	}

	shouldComponentUpdate(nextProps) {
		console.log("prev", this.props.counter);
		console.log("next", nextProps.counter);

		return true;
	}

	render() {
		const { counter, decrease, increase, load, data } = this.props;
		return (
			<div>
				<h1>Counter {counter}</h1>
				<Loader flag={load}>
					{data.map(el => (
						<div key={el.id}>{el.title}</div>
					))}
				</Loader>
				<button onClick={() => increase(10)}>INC</button>
				<button onClick={decrease}>DEC</button>

				<div className="box-image" />
			</div>
		);
	}
}

const mapStateToProps = state => {
	return {
		counter: state.counter.count,
		load: state.request.isFetching,
		data: state.request.data
	};
};

// const mapDispatchToProps = dispach => {
// 	return {
// inc: payload => dispach(actions.increase(payload)),
// 		dec: () => dispach(actions.decrease())
// 	};
// };

// const mapDispatchToProps = dispach => bindActionCreators({ increase, decrease  }, dispach)

export default connect(
	mapStateToProps,
	{ increase, decrease, doRequest }
)(Count);
